import sys

from typing import Tuple, Optional, Collection, Set, List, Mapping, cast

if sys.version_info >= (3, 10):
    from typing import TypeAlias
else:
    TypeAlias = Any  # Fallback for older versions


from mc308.logics.bool import BoolFormula
from mc308.auto.sts import SymbolicTS, from_vmt, get_next


from pysmt.logics import QF_BOOL
from pysmt.shortcuts import (
    get_env,Symbol, TRUE, FALSE, And, Or, Not, Implies, Iff,
    is_sat, is_valid, get_model,
    Solver,
    binary_interpolant
)

from pysmt.solvers.solver import Model


def kind(ts : SymbolicTS, prop: BoolFormula, max_k : int) -> Optional[bool]:
    raise NotImplementedError

def itp(ts : SymbolicTS, prop: BoolFormula, max_k : int) -> bool:
    raise NotImplementedError
